# Create and Destroy Topologies

## Functions

HWLOC_DECLSPEC int | hwloc_topology_init (hwloc_topology_t *topologyp)
| Allocate a topology context.
HWLOC_DECLSPEC int | hwloc_topology_load (hwloc_topology_t topology)
| Build the actual topology.
HWLOC_DECLSPEC void | hwloc_topology_destroy (hwloc_topology_t topology)
| Terminate and free a topology context.
HWLOC_DECLSPEC void | hwloc_topology_check (hwloc_topology_t topology)
| Run internal checks on a topology structure.

## Function Documentation

HWLOC_DECLSPEC void hwloc_topology_check | ( | hwloc_topology_t | topology | ) |

Run internal checks on a topology structure.

Parameters:

  | topology | is the topology to be checked

HWLOC_DECLSPEC void hwloc_topology_destroy | ( | hwloc_topology_t | topology | ) |

Terminate and free a topology context.

Parameters:

  | topology | is the topology to be freed

HWLOC_DECLSPEC int hwloc_topology_init | ( | hwloc_topology_t * | topologyp | ) |

Allocate a topology context.

Parameters:

  `[out]` | topologyp | is assigned a pointer to the new allocated context.

Returns:
  0 on success, -1 on error.

HWLOC_DECLSPEC int hwloc_topology_load | ( | hwloc_topology_t | topology | ) |

Build the actual topology.

Build the actual topology once initialized with hwloc_topology_init() and tuned with hwlocality_configuration routine. No other routine may be called earlier using this topology context.

Parameters:

  | topology | is the topology to be loaded with objects.

Returns:
  0 on success, -1 on error.

See also:
  Configure Topology Detection